<?php
/**
 * squared Theme Customizer
 *
 * @package squared
 */

/**
 * Add postMessage support for site title and description for the Theme Customizer.
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function squared_customize_register( $wp_customize ) {
	$wp_customize->get_setting( 'blogname' );
	$wp_customize->get_setting( 'blogdescription' );
	$wp_customize->get_setting( 'header_textcolor' );
	$wp_customize->remove_control( 'header_textcolor' );
	$wp_customize->remove_setting( 'background_color' );

	// if ( isset( $wp_customize->selective_refresh ) ) {
	// 	$wp_customize->selective_refresh->add_partial( 'blogname', array(
	// 		'selector'        => '.site-title a',
	// 		'render_callback' => 'squared_customize_partial_blogname',
	// 	) );
	// 	$wp_customize->selective_refresh->add_partial( 'blogdescription', array(
	// 		'selector'        => '.site-description',
	// 		'render_callback' => 'squared_customize_partial_blogdescription',
	// 	) );
	// }

/*************************************************************************
CUSTOM
*************************************************************************/
$wp_customize->remove_section( 'colors' , array(
    'title'     => __( 'colors', 'squared-viaductone' ),
) );

/*********************************
squared Custom Options
*********************************/
$wp_customize->add_section( 'custom-options' , array(
    'title'     => __( 'Custom Options', 'squared-viaductone' ),
		'priority'	=> '20',
) );

/*********************************
Site-Title flex direction
*********************************/
 $wp_customize->add_setting( 'squared_title_flex', array(
   'capability' => 'edit_theme_options',
   'sanitize_callback' => 'squared_titleflex_sanitize_checkbox',
 ) );

		 $wp_customize->add_control( 'squared_title_flex', array(
		   'type' => 'checkbox',
		   'section' => 'title_tagline',
		   'label' => __( 'Tagline below or to the right of Site Title', 'squared-viaductone' ),
		 	 'description'  => __( 'Default: Right', 'squared-viaductone' ),
		 ) );

 function squared_titleflex_sanitize_checkbox( $checked ) {
   // Boolean check.
   return ( ( isset( $checked ) && true == $checked ) ? true : false );
 }

/*********************************
Site Title and Tagline Color
*********************************/
$wp_customize->add_setting( 'squared_header_text_color', array(
	'default' => '#aaaaaa',
	'sanitize_callback' => 'squared_header_text_sanitize',

) );

		// add color picker control
		$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'squared_header_text_color', array(
			'label'     => __( 'Site Title and Tagline', 'squared-viaductone' ),
			'section'   => 'custom-options',
			'settings'   => 'squared_header_text_color'
		) )
	);



/*********************************
Header Background Color
*********************************/
$wp_customize->add_setting( 'squared_header_background', array(
		'default' => '#26303c',
	'sanitize_callback' => 'sanitize_hex_color',

	) );


	// add color picker control
		$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'squared_header_background', array(
			'label'     => __( 'Header Background', 'squared-viaductone' ),
			'section'   => 'custom-options',
			'settings'   => 'squared_header_background'
		) )
	);



/*********************************
Menu Text Toggle
*********************************/
$wp_customize->add_setting( 'squared_menu_text_toggle', array(
	'capability' => 'edit_theme_options',
	'sanitize_callback' => 'squared_sanitize_checkbox',
) );

		// add checkbox
		$wp_customize->add_control( 'squared_menu_text_toggle', array(
			'type' => 'checkbox',
			'section' => 'custom-options',
			'label' => __( 'Toggle Menu Text', 'squared-viaductone' ),
			'description'  => __( 'Toggle menu text on large screens', 'squared-viaductone' ),
		) );

		function squared_sanitize_checkbox( $checked ) {
			// Boolean check.
			return ( ( isset( $checked ) && true == $checked ) ? true : false );
		}


/*********************************
Link Color
*********************************/
// add color setting for all links (a)
$wp_customize->add_setting( 'link_color', array(
	'default' => '#aaaaaa',
	'sanitize_callback' => 'sanitize_hex_color',

) );

// add color setting for menu-item (a)
$wp_customize->add_setting( 'squared_menu_link_color', array(
	'default' => '#aaaaaa',
	'sanitize_callback' => 'sanitize_hex_color',

) );

// add color setting for menu-item (icon)
$wp_customize->add_setting( 'squared_menu_icon_color', array(
	'default' => '#aaaaaa',
	'sanitize_callback' => 'sanitize_hex_color',

) );

		// add color picker control
		$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'link_color', array(
			'label' => 'Link Color',
			'section' => 'custom-options',
			'settings' => 'link_color',
		) ) );

		/*********************************
		Link Hover Color
		*********************************/
		$wp_customize->add_setting( 'squared_link_hover', array(
			'default' => '#efefef',
			'sanitize_callback' => 'sanitize_hex_color',
		) );

				// add color picker control
				$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'squared_link_hover', array(
					'label' => 'Link Hover',
					'section' => 'custom-options',
					'settings' => 'squared_link_hover',
				) ) );

/*********************************
Primary Background Color
*********************************/
$wp_customize->add_setting( 'squared_background_color', array(
	'default' => '#26303c',
	'sanitize_callback' => 'sanitize_hex_color',

) );

		// add control for site background color
		$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'squared_background_color', array(
			'label'     => __( 'Background Color', 'squared-viaductone' ),
			'section'   => 'custom-options',
			'settings'   => 'squared_background_color'
		) )
		);

/*********************************
Primary Text Color
*********************************/
		$wp_customize->add_setting( 'squared_body_text_color', array(
	'default' => '#aaaaaa',
	'sanitize_callback' => 'sanitize_hex_color',

) );

		// add control for site body text color
		$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'squared_body_text_color', array(
			'label'     => __( 'Primary Text Color', 'squared-viaductone' ),
			'section'   => 'custom-options',
			'settings'   => 'squared_body_text_color'
		) )
		);


/*********************************
Secondary Background Color
*********************************/
$wp_customize->add_setting( 'squared_secondary_color', array(
	'default' => '#cccccc',
	'sanitize_callback' => 'sanitize_hex_color',

) );

		// add control for secondary background
		$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'squared_secondary_color', array(
			'label'     => __( 'Secondary Color', 'squared-viaductone' ),
			'section'   => 'custom-options',
			'settings'   => 'squared_secondary_color',
			'description'  => __( 'Background for single posts', 'squared-viaductone' ),
		) )
		);

/*********************************
Secondary Text Color
*********************************/
$wp_customize->add_setting( 'squared_secondary_text_color', array(
	'default' => '#222222',
	'sanitize_callback' => 'sanitize_hex_color',

) );

		// add control for secondary text color
		$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'squared_secondary_text_color', array(
			'label'     => __( 'Secondary Text Color', 'squared-viaductone' ),
			'section'   => 'custom-options',
			'settings'   => 'squared_secondary_text_color'
		) )
		);

/*********************************
Grid Icons Color
*********************************/
$wp_customize->add_setting( 'squared_grid_text', array(
	'default' => '#aaaaaa',
	'sanitize_callback' => 'sanitize_hex_color',

) );

		// add color picker control
		$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'squared_grid_text', array(
			'label' => 'Grid Items Color',
			'section' => 'custom-options',
			'settings' => 'squared_grid_text',
		) ) );

		/*********************************
		Grid Icons Hover
		*********************************/
			$wp_customize->add_setting( 'squared_grid_hover', array(
				'default' => '#efefef',
				'sanitize_callback' => 'sanitize_hex_color',

			) );

					// add color picker control
					$wp_customize->add_control( new WP_Customize_Color_Control( $wp_customize, 'squared_grid_hover', array(
						'label' => 'Grid Items Hover',
						'section' => 'custom-options',
						'settings' => 'squared_grid_hover',
					) ) );

					//
					// function squared_grid_hover_sanitize( $checked ) {
					// 	// Boolean check.
					// 	return ( ( isset( $checked ) && true == $checked ) ? true : false );
					// }

					/*********************************
					Grid Title Toggle
					*********************************/
					$wp_customize->add_setting( 'squared_grid_text_toggle', array(
					  'capability' => 'edit_theme_options',
					  'sanitize_callback' => 'squared_grid_sanitize_checkbox',
					) );

							$wp_customize->add_control( 'squared_grid_text_toggle', array(
							  'type' => 'checkbox',
							  'section' => 'custom-options', // Add a default or your own section
							  'label' => __( 'Toggle Grid Item Title', 'squared-viaductone' ),
								'description'  => __( 'Toggle grid title text hover behavior', 'squared-viaductone' ),
							) );

							function squared_grid_sanitize_checkbox( $checked ) {
							  // Boolean check.
							  return ( ( isset( $checked ) && true == $checked ) ? true : false );
							}


}
add_action( 'customize_register', 'squared_customize_register' );

/**
 * Render the site title for the selective refresh partial.
 *
 * @return void
 */
function squared_customize_partial_blogname() {
	bloginfo( 'name' );
}

/**
 * Render the site tagline for the selective refresh partial.
 *
 * @return void
 */
function squared_customize_partial_blogdescription() {
	bloginfo( 'description' );
}

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function squared_customize_preview_js() {
	wp_enqueue_script( 'squared-viaductone-customizer', get_template_directory_uri() . '/js/customizer.js', array( 'customize-preview' ), '20151215', true );
}
add_action( 'customize_preview_init', 'squared_customize_preview_js' );
