<?php
/*
Plugin Name: viaductone Contact Form
Plugin URI: http://viaduct.one
Description: Simple Contact Form w/ Widget
Version: 1.0
Author: AWZR
Author URI: http://viaduct.one
*/

function html_form_code() {
	echo '<form action="' . esc_url( $_SERVER['REQUEST_URI'] ) . '" method="post">';
	echo '<p>';
	echo 'Your Name (required) <br/>';
	echo '<input type="text" name="cf-name" pattern="[a-zA-Z0-9 ]+" value="' . ( isset( $_POST["cf-name"] ) ? esc_attr( $_POST["cf-name"] ) : '' ) . '" size="40" />';
	echo '</p>';
	echo '<p>';
	echo 'Your Email (required) <br/>';
	echo '<input type="email" name="cf-email" value="' . ( isset( $_POST["cf-email"] ) ? esc_attr( $_POST["cf-email"] ) : '' ) . '" size="40" />';
	echo '</p>';
	echo '<p>';
	echo 'Subject (required) <br/>';
	echo '<input type="text" name="cf-subject" pattern="[a-zA-Z ]+" value="' . ( isset( $_POST["cf-subject"] ) ? esc_attr( $_POST["cf-subject"] ) : '' ) . '" size="40" />';
	echo '</p>';
	echo '<p>';
	echo 'Your Message (required) <br/>';
	echo '<textarea rows="10" cols="35" name="cf-message">' . ( isset( $_POST["cf-message"] ) ? esc_attr( $_POST["cf-message"] ) : '' ) . '</textarea>';
	echo '</p>';
	echo '<p><input type="submit" name="cf-submitted" value="Send"></p>';
	echo '</form>';
}

function deliver_mail() {

	// if the submit button is clicked, send the email
	if ( isset( $_POST['cf-submitted'] ) ) {

		// sanitize form values
		$name    = sanitize_text_field( $_POST["cf-name"] );
		$email   = sanitize_email( $_POST["cf-email"] );
		$subject = sanitize_text_field( $_POST["cf-subject"] );
		$message = esc_textarea( $_POST["cf-message"] );

		// get the blog administrator's email address
		$to = get_option( 'admin_email' );

		$headers = "From: $name <$email>" . "\r\n";

		// If email has been process for sending, display a success message
		if ( wp_mail( $to, $subject, $message, $headers ) ) {
			echo '<div>';
			echo '<p>Thanks for contacting me, expect a response soon.</p>';
			echo '</div>';
		} else {
			echo 'An unexpected error occurred';
		}
	}
}






class squared_Form_Widget extends WP_Widget {
  /**
  * To create the example widget all four methods will be
  * nested inside this single instance of the WP_Widget class.
  **/
	public function __construct() {
	    $widget_options = array(
	      'classname' => 'squared_Form_widget',
	      'description' => 'This is a Form Widget',
	    );
	    parent::__construct( 'squared_form_widget', 'Contact Form Widget', $widget_options );
	  }

	public function widget( $args, $instance ) {
		  $title = apply_filters( 'widget_title', $instance[ 'title' ] );
		  $blog_title = get_bloginfo( 'name' );
		  $tagline = get_bloginfo( 'description' );
		  echo $args['before_widget'] . $args['before_title'] . $title . $args['after_title'];

			deliver_mail();
		  echo html_form_code();


		  echo $args['after_widget'];
		}


		public function form( $instance ) {
		  $title = ! empty( $instance['title'] ) ? $instance['title'] : ''; ?>
		  <p>
		    <label for="<?php echo $this->get_field_id( 'title' ); ?>">Title:</label>
		    <input type="text" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" value="<?php echo esc_attr( $title ); ?>" />
		  </p><?php
		}

		public function update( $new_instance, $old_instance ) {
		  $instance = $old_instance;
		  $instance[ 'title' ] = strip_tags( $new_instance[ 'title' ] );
		  return $instance;
		}


}

function squared_register_Form_Widget() {
  register_widget( 'squared_Form_Widget' );
}
add_action( 'widgets_init', 'squared_register_Form_Widget' );








?>
