<?php
/*
Plugin Name: viaductone Pages in Widgets
Plugin URI: http://viaduct.one
Description: Pages in Widgets plugin
Version: 1.0
Author: AWZR
Author URI: http://viaduct.one
*/

/*********************************************
Pages Widget
***********************************************/

	if ( ! defined( 'ABSPATH' ) ) {
		exit;
	}

	add_action( 'widgets_init', 'pagesaswidgets_pages' );
	function pagesaswidgets_pages() {
		register_widget( 'pagesaswidgets_page_section' );
	}

	class pagesaswidgets_page_section extends WP_Widget {

		function __construct(){
			parent::__construct('pagesaswidgets_page_section',__( 'Pages as Widgets', 'squared-viaductone' ),
				array(
					'description' => __( 'A general layout for page sections.', 'squared-viaductone' ),
					'classname'   => 'pagesaswidgets_page_section'
				)
			);
		}
	/*
	* Output Type Selection
	*/
		function form($instance){
			$currentInstance = $instance;
			$instance = wp_parse_args( (array) $instance, array('pageID' => '','titleEnable' => 'true') );
			if(isset($currentInstance['title']) == false){
				$currentInstance['title'] = "";
			}
			if(isset($currentInstance['pageID']) == false){
				$currentInstance['pageID'] = 1;
			}
			if(isset($currentInstance['titleEnable']) == false){
				$currentInstance['titleEnable'] = 'true';
			}
			if(isset($currentInstance['customCssClass']) == false){
				$currentInstance['customCssClass'] = '';
			}
			if(isset($currentInstance['outputtype']) == false){
				$currentInstance['outputtype'] = "normal";
			}
			?>
			<p style="font-style: italic;"><small><?php _e( 'Select the page here and then edit the page under the pages tab on the left.', 'squared-viaductone' ); ?></small></p>
			<p><label for="<?php echo $this->get_field_id('pageID'); ?>"><span style="float:left; width:100%;"><?php _e( 'Page:', 'squared-viaductone' ); ?></span>
			<select class="large-text" style="width:100%;" id="<?php echo $this->get_field_id('pageID'); ?>" name="<?php echo $this->get_field_name('pageID'); ?>">
				<?php
					$args = array( 'post_type' => 'page', 'post_status' => 'publish', 'posts_per_page' => -1 );
					$pageList = new WP_Query( $args );
					while ( $pageList->have_posts() ){
						$pageList->the_post();
						$pageid = get_the_ID();
					?>
						<option value="<?php echo $pageid; ?>" <?php if($pageid == intval($currentInstance['pageID']) && $currentInstance['pageID'] != null){echo 'selected="selected"';} ?>><?php echo the_title(); ?></option>
					<?php
					}
					wp_reset_postdata();
				?>
			</select>
			</label></p>
			<p><label for="<?php echo $this->get_field_id('titleEnable'); ?>-yes"><span style="width:100%; float:left;"><?php _e( 'Show Page Title:', 'squared-viaductone' ); ?></span></label>

			<label for="<?php echo $this->get_field_id('titleEnable'); ?>-yes"><?php _e( 'Yes:', 'squared-viaductone' ); ?> <input type="radio" value="true" name="<?php echo $this->get_field_name('titleEnable'); ?>" id="<?php echo $this->get_field_id('titleEnable'); ?>-yes" <?php if($currentInstance['titleEnable'] == 'true'){echo 'checked="checked"';} ?>/></label>
			<label for="<?php echo $this->get_field_id('titleEnable'); ?>-no"><?php _e( 'No:', 'squared-viaductone' ); ?> <input type="radio" value="false" name="<?php echo $this->get_field_name('titleEnable'); ?>" id="<?php echo $this->get_field_id('titleEnable'); ?>-no" <?php if($currentInstance['titleEnable'] == 'false'){echo 'checked="checked"';} ?>/></label></p>

			<p>	<label for="<?php echo $this->get_field_id('customCssClass'); ?>"><?php _e( 'CSS Class:', 'squared-viaductone' ); ?></label><br/>
	        <input class="large-text" id="<?php echo $this->get_field_id('customCssClass'); ?>" name="<?php echo $this->get_field_name('customCssClass'); ?>" value="<?php echo $currentInstance['customCssClass']; ?>">
	        </p>

	        <p><label for="<?php echo $this->get_field_id('outputtype'); ?>"><?php _e( 'Output Type:', 'squared-viaductone' ); ?></label><br/>
	        	<select class="large-text" style="width:100%;" id="<?php echo $this->get_field_id('outputtype'); ?>" name="<?php echo $this->get_field_name('outputtype'); ?>">
	        		<option value="normal" <?php if($currentInstance['outputtype'] == "normal"){echo 'selected';}?>><?php _e('Normal', 'squared-viaductone' ); ?></option>
	        		<option value="plaintext" <?php if($currentInstance['outputtype'] == "plaintext"){echo 'selected';}?>><?php _e('Plain Text', 'squared-viaductone' ); ?></option>
	        		<option value="forceptag" <?php if($currentInstance['outputtype'] == "forceptag"){echo 'selected';}?>><?php _e('Force P Tags', 'squared-viaductone' ); ?></option>
	        	</select>
	        </p>
	        <br/>
			<?php
		}

	/*
	* Update Widget
	*/
		function update($new_instance, $old_instance){
	   		$instance = $old_instance;
	    	$instance['pageID'] = $new_instance['pageID'];
			$instance['titleEnable'] = $new_instance['titleEnable'];
			$instance['customCssClass'] = $new_instance['customCssClass'];
			$instance['outputtype'] = $new_instance['outputtype'];
	    	return $instance;
	    }

	/*
	* Output Widget
	*/
		function widget($args, $instance){
			extract($args, EXTR_SKIP);
			$pageID = $instance['pageID'];
			$titleEnable = $instance['titleEnable'];
			$customCssClass = $instance['customCssClass'];
			$outputType = $instance['outputtype'];
	    	echo $before_widget;
			$args = array( 'page_id' => $pageID );
			$page = new WP_Query( $args );
			//$page = $page->the_post();
			if ( $page->have_posts() ) :
				while ( $page->have_posts() ) : $page->the_post();
				    if($titleEnable == 'true'){ ?>
						<h4 class="widget-title widgettitle"><?php echo the_title(); ?></h4>
						<?php } ?>
						<div class="<?php echo (($customCssClass)?$customCssClass:'homepage_section'); ?>">
							<?php
							if($outputType == 'plaintext'){
								echo strip_tags(get_the_content());
							}
							else if($outputType == 'forceptags'){
								$content = get_the_content();
								$rsp = array("\r\n&nbsp;\r\n","\n&nbsp;\n","\r&nbsp;\r");
								$content = str_replace($rsp,"</p><p>",$content);
								$rsp2 = array("\r\n\r\n&nbsp;\r\n\r\n","\r\r&nbsp;\r\r","\n\n&nbsp;\n\n");
								$content = str_replace($rsp,"</p><br/><p>",$content);
							}
							else{
								the_content();
							}
							?>
							</div>
						<?php
				endwhile;
			endif;
	   		echo $after_widget;
	   		wp_reset_postdata();
		}

	}

/*********************************************
End of Pages Widget
***********************************************/

?>
